player = class:new()
playerfriction = 30
airfriction = 25

playerimage = love.graphics.newImage("Graphics/Hero.png")
playerquads = {}
for x = 1, 5 do
	playerquads[x] = love.graphics.newQuad((x-1)*16, 0, 16, 29, playerimage:getWidth(), playerimage:getHeight())
end

function player:init(x, y, layer)
	self.x = x
	self.y = y
	self.width = 1
	self.height = 29/16
	self.xSpeed = 0
	self.ySpeed = 0
	self.active = true
	self.layer = layer
	self.shouldfall = true
	self.quad = 1

	self.animationtimer = 0
	self.animationdirection = "up"

	self.rotation = 0
end

function player:update(dt)
	if self.still then
		self.quad = 1
		self.stilltimer = self.stilltimer + dt
		if self.stilltimer > .5 then
			screenflash = true
			self.stilltimer = 0
		end
		return
	end
	self:movement(dt)
	self:scroll()
	if self.x < 0 then
		self.x = 0
		self.xSpeed = 0
	elseif self.x > mapwidth-2 then
		self.x = mapwidth-2
		self.xSpeed = 0
	end

	local speed = self.ySpeed
	if speed > 0 then
		speed = self.ySpeed - gravity*love.timer.getDelta()
	elseif speed < 0 then
		speed = self.ySpeed + gravity*love.timer.getDelta()
	end
	if speed ~= 0 then
		self.quad = 5
	else
	
		if love.keyboard.isDown("left") or love.keyboard.isDown("right") then
			if self.quad < 2 or self.quad > 4 then
				self.quad = 2
			end
			self.animationtimer = self.animationtimer + dt
			if self.animationtimer > .1 then
				--print(self.quad)
				self.animationtimer = 0
				if self.animationdirection == "up" then
					self.quad = self.quad + 1
				elseif self.animationdirection == "down" then
					self.quad = self.quad - 1
				end
				--print(self.quad)
				if self.quad > 4 then 
					self.quad = 3
					self.animationdirection = "down"
				elseif self.quad < 2 then
					self.animationdirection = "up"
					self.quad = 3
				end
			end
		else
			self.quad = 1
		end
	end
	if self.rotation < 0 then
		self.rotation = 0
	end
	if self.rotation > math.pi then
		self.rotation = math.pi
	end
	if gravity > 0 and self.rotation > 0 then
		self.rotation = self.rotation - math.pi*4*dt
	end
	if gravity < 0 and self.rotation < math.pi then
		self.rotation = self.rotation + math.pi*4*dt
	end
	lastcollided = "nothing"

	if self.y*blocksize > screenheight then
		refreshlevel = true
		screenflash = true
	end
end

function player:draw()
	love.graphics.setColor(255, 255, 255)
	local scalex, offx = scale, 0
	if self.dir == "left" and gravity > 0 then
		scalex, offx = -scale, 16
	elseif self.dir == "right" and gravity < 0 then
		scalex, offx = -scale, 16
	end
	love.graphics.push()
	love.graphics.translate((self.x+self.width/2)*blocksize, (self.y+self.height/2)*blocksize)
    love.graphics.rotate(self.rotation)
    love.graphics.translate(-(self.x+self.width/2)*blocksize, -(self.y+self.height/2)*blocksize)
	--[[local offy = 0
	if gravity < 0 then
		offy = 29
		if self.dir == "right" then
			offx = 0
		elseif self.dir == "left" then
			offx = 16
		end
	end--]]
	love.graphics.drawq(playerimage, playerquads[self.quad], self.x*blocksize, self.y*blocksize, 0, scalex, scale, offx, offy)
	love.graphics.setColor(0, 0, 0)
	love.graphics.pop()
end

function player:keypressed(key)
	local speed = self.ySpeed
	if speed > 0 then
		speed = self.ySpeed - gravity*love.timer.getDelta()
	elseif speed < 0 then
		speed = self.ySpeed + gravity*love.timer.getDelta()
	end
	if key == "z" and speed == 0 and not self.still then
		if gravity > 0 then
			self.y = self.y - 1/16
			self.ySpeed = -13
		else
			self.y = self.y + 1/16
			self.ySpeed = 13
		end
	end
	if key == "left" and lastcollided == "right" and not self.still then
		self.x = self.x-.5/16
	elseif key == "right" and lastcollided == "left" and not self.still then
		self.x = self.x+.5/16
	end

	if key == "s" and not self.still and currentlayer < maxlayer then
		if not fullentitymap[currentlayer+1][math.floor(self.x)][math.floor(self.y)] and not fullentitymap[currentlayer+1][math.floor(self.x)][math.floor(self.y+1)]
		and not fullentitymap[currentlayer+1][math.floor(self.x+self.width)][math.floor(self.y)] and not fullentitymap[currentlayer+1][math.floor(self.x+self.width)][math.floor(self.y+1)] then
			--currentlayer = currentlayer + 1
			--self.layer = self.layer + 1
			layertransition = true
			movelayer = "forward"
			playsound(transitionsound)
	
		else
			playsound(errorsound)
		end
	end
	if key == "a" and not self.still and currentlayer > 1 then
		if not fullentitymap[currentlayer-1][math.floor(self.x)][math.floor(self.y)] and not fullentitymap[currentlayer-1][math.floor(self.x)][math.floor(self.y+1)]
		and not fullentitymap[currentlayer-1][math.floor(self.x+self.width)][math.floor(self.y)] and not fullentitymap[currentlayer-1][math.floor(self.x+self.width)][math.floor(self.y+1)] then
			--currentlayer = currentlayer - 1
			--self.layer = self.layer - 1
			layertransition = true
			movelayer = "backward"
			playsound(transitionsound)
		else
			playsound(errorsound)
		end
	end

	if key == "x" then
		for j, k in pairs(inputs) do
			for i, v in pairs(objects[k]) do
				if speed == 0 then
					if aabb(self.x, self.y, self.width, self.height, v.x-1, v.y, v.width+1, v.height) and v.layer == currentlayer then
						v.on = not v.on
						playsound(switchsound)
					end
				end
			end
		end
	end
end

function player:movement(dt)
	if love.keyboard.isDown("left") and self.xSpeed > -7 then
		if self.xSpeed > 0 then
			self.xSpeed = 0
		end
		self.dir = "left"
		self.xSpeed = self.xSpeed - 6*dt
	end
	if love.keyboard.isDown("right") and self.xSpeed < 7 then
		if self.xSpeed < 0 then
			self.xSpeed = 0
		end
		self.dir = "right"
		self.xSpeed = self.xSpeed + 6*dt
	end
	if not love.keyboard.isDown("left") and not love.keyboard.isDown("right") then
		local speed = self.ySpeed
		if speed > 0 then
			speed = self.ySpeed - gravity*love.timer.getDelta()
		elseif speed < 0 then
			speed = self.ySpeed + gravity*love.timer.getDelta()
		end
		if speed ~= 0 then
			if self.xSpeed > 2/16 then
				self.xSpeed = self.xSpeed - airfriction*dt
			elseif self.xSpeed < -2/16 then
				self.xSpeed = self.xSpeed + airfriction*dt
			else
				self.xSpeed = 0
			end
		else
			if self.xSpeed > 2/16 then
				self.xSpeed = self.xSpeed - playerfriction*dt
			elseif self.xSpeed < -2/16 then
				self.xSpeed = self.xSpeed + playerfriction*dt
			else
				self.xSpeed = 0
			end
		end
		self.xSpeed = math.floor(self.xSpeed*blocksize)/blocksize
	end
end

function player:upcollide(v, name)
	if name == "key" or name == "keydoor" then
		if self:genericcollide(v, name) == "nocollide" then
			--return "nocollide"
		end
	end
	--lastcollided = "up"
end

function player:downcollide(v, name)
	if name == "key" or name == "keydoor" then
		if self:genericcollide(v, name) == "nocollide" then
			--return "nocollide"
		end
	end
	if name == "exit" and not v.startplatform then
		self.y = v.y - self.height
		self.x = v.x + v.width/2 - self.width/2
		if not self.still then
			self.still = true
			self.stilltimer = 0
			playsound(endlevelsound)
		end
		self.standingonexit = v
	end
end

function player:leftcollide(v, name)
	if name == "key" or name == "keydoor" then
		if self:genericcollide(v, name) == "nocollide" then
			--return "nocollide"
		end
	end
	lastcollided = "left"
end

function player:rightcollide(v, name)
	if name == "key" or name == "keydoor" then
		if self:genericcollide(v, name) == "nocollide" then
			--return "nocollide"
		end
	end
	lastcollided = "right"
end

function player:genericcollide(v, name)
	if name == "exit" then
		gotonextlevel = true
	elseif name == "key" then
		if not self.haskey then
			self.haskey = true
			v.kill = true
		end
	elseif name == "keydoor" then
		if self.haskey and not v.retract then
			self.haskey = false
			v.retract = true
			playsound(dooropensound)
			--return "nocollide"
		end
	end
end

function player:scroll(dt)
	if xscroll >= 0 and xscroll <= mapwidth-1 then
		if self.x < xscroll+screenblockwidth*1/4 then
			xscroll = self.x - screenblockwidth*1/4 
		elseif self.x > xscroll + screenblockwidth *1/2 then
			xscroll = self.x - screenblockwidth*1/2
		end
	end  
	if xscroll < 0 then
		xscroll = 0
	end 
	if xscroll+screenblockwidth >= mapwidth-1 then
		xscroll = mapwidth-1-screenblockwidth
	end
end