local abs = math.abs
function resetcollisionoptions()
	collisionoptions = {}
	collisionoptions["player"] = {"all"}
end
resetcollisionoptions()
function physicsupdate(dt)
	for v1name, table in pairs(objects) do
		for _, v1 in pairs(table) do
			local canpass
			if collisionoptions[v1name] then
				if #collisionoptions[v1name] > 0 then 
					canpass = true
				end
			end
			if canpass then
				if v1.active then
					local horcollision, vercollision

					if v1.shouldfall then
						v1.ySpeed = v1.ySpeed + (v1.gravity or gravity)*dt
					end
					local onslope = false
					local v1x, v1y = math.floor(v1.x), math.floor(v1.y)
					for x = v1x-1, v1x+v1.width+1 do
						for y = v1y-1, v1y+v1.height+1 do
							if fullentitymap[v1.layer][x] then
								if fullentitymap[v1.layer][x][y] then
									local v2name, v2 = fullentitymap[v1.layer][x][y][1], objects[fullentitymap[v1.layer][x][y][1]][fullentitymap[v1.layer][x][y][2]]
									local canpass
									if collisionoptions[v1name] then
										if #collisionoptions[v1name] > 0 and v1 ~= v2 then 
											for i, v in pairs(collisionoptions[v1name]) do
												if v == v2name or v == "all" then
													canpass = true
													break
												end
											end
										end
									end

									if v1name == v2name then
										canpass = false
									end
									if v1.static or v2.static then
										canpass = false
									end
					
									if canpass then
										if v2name ~= "slope" then
											if aabb(v1.x, v1.y, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) and not v1.onslope and v2.active then
												local hor, ver = checkcollision(v1name, v1, v2name, v2, dt)
												if hor then
													horcollision = true
												end
												if ver then
													vercollision = true
												end
											end

										else

							--Incredibly un-optimized collision check
							--Don't look children.
											local pointcollide
											if v1.xSpeed >= 0 then
												if (v2.x1 > v1.x and v2.x1 < v1.x + v1.width and v2.y1 > v1.y and v2.y1 < v1.y + v1.height) or
												(v2.x2 > v1.x and v2.x2 < v1.x + v1.width and v2.y2 > v1.y and v2.y2 < v1.y + v1.height) or
												(v2.x3 > v1.x and v2.x3 < v1.x + v1.width and v2.y3 > v1.y and v2.y3 < v1.y + v1.height) then
													pointcollide = true
												end
											end
				
											if not pointcollide then
												local x, y = {v2.x1, v2.x2, v2.x3}, {v2.y1, v2.y2, v2.y3}
												for i = 1, 3 do
													local second = i+1
													if i+1 > 3 then
														second = 1
													end
													if findlineIntersect(x[i], y[i], x[second], y[second], v1.x, v1.y, v1.x+v1.width, v1.y, true, true) or
													findlineIntersect(x[i], y[i], x[second], y[second], v1.x, v1.y, v1.x, v1.y+v1.height, true, true) or
													findlineIntersect(x[i], y[i], x[second], y[second], v1.x, v1.y + v1.height, v1.x + v1.width, v1.y+v1.height, true, true) or
													findlineIntersect(x[i], y[i], x[second], y[second], v1.x + v1.width, v1.y, v1.x+v1.width, v1.y+v1.height, true, true) then
														pointcollide = true
														--break
													end
												end
											end
											if v2.slope < 0 then
												if v1.x + v1.width > v2.x3 then
													pointcollide = false
												end
											else
												if v1.x < v2.x3 then
													pointcollide = false
												end
											end
											if pointcollide then
												onslope = true
												local xup = v1.x+v1.width-v2.x1
												local y = v2.y1
												if v2.slope > 0 then
													xup = v2.x3 - v1.x
													y = v2.y3+3.5/16
												end
												--if xup > -v2.slope*v1.width*2 and xup < -v2.slope*v1.width*3 then
													v1.y = y-v1.height-xup
													vercollision = true
													horcollision = false
													v1.ySpeed = 0
													if v1.downcollide then
														v1:downcollide(v2, v2name)
													end
												--end
												v1.onslopeequation = v2.slope
												v1.onslopecoords = v2
								--break
											end
										end
									end
					
								end
								v1.onslope = onslope

							end
						end
					end

					if not horcollision then
						v1.x = v1.x + v1.xSpeed * dt
					end
					if not vercollision then
						v1.y = v1.y + v1.ySpeed * dt
					end
					if not horcollision and not vercollision then
						if v1.nocollide then
							v1:nocollide()
						end
					end

				end
			end
		end
	end
end

function checkcollision(v1name, v1, v2name, v2, dt)

	--K, we got our first set of values.

	local mtd = {} --Make our mtd table.
	--I don't like math too much anymore

	local left = v2.x - (v1.x + v1.width)
	local right = (v2.x + v2.width) - v1.x
	local up = v2.y - (v1.y + v1.height)
	local down = (v2.y + v2.height) - v1.y
	if left > 0 or right < 0 or up > 0 or down < 0 then --Not colliding. This is the easy part lol.
		return false
	end
	if left > 0 or right < 0 or up > 0 or down < 0 then --Not colliding. This is the easy part lol.
		return false
	end

	local vertype, hortype

	if abs(left) < right then --Determine the collision on both axises? Axis'? I give up. On the x and y axis
		mtd.x = left
		hortype = "left"
	else
		mtd.x = right
		hortype = "right"
	end

	if abs(up) < down then
		mtd.y = up
	else
		mtd.y = down
	end
	if abs(mtd.x) < abs(mtd.y) then
		ver = false
		hor = true
	else
		hor = false
		ver = true
	end
	local oldy, oldx = v1.x, v1.y
	if ver then
		if v1.ySpeed > 0 then
			if not v1.passive and not v2.passive then
				v1.y = v2.y - v1.height
			end
			if v1.downcollide then
				if v1:downcollide(v2, v2name) == "nocollide" then
					return false, false
				end
			end
		elseif v1.ySpeed < 0 then
			if not v1.passive and not v2.passive then
				v1.y = v2.y + v2.height
			end
			if v1.upcollide then
				if v1:upcollide(v2, v2name) == "nocollide" then
					return false, false
				end
			end
		end
		if not v1.passive and not v2.passive then
			v1.ySpeed = 0
		end
	end

	if hor then
		if not v1.passive and not v2.passive then
			if hortype == "left" then
				v1.x = v2.x - v1.width
			elseif hortype == "right" then
				v1.x = v2.x + v2.width
			end
		end
		if math.floor(v1.xSpeed*blocksize) > 0 or (math.floor(v1.xSpeed*blocksize) == 0 and v2.xSpeed < 0) then
			if v1.rightcollide then
				if v1:rightcollide(v2, v2name) == "nocollide" then
					return false, false
				end
			end
		end
		if math.floor(v1.xSpeed*blocksize) < 0 or (math.floor(v1.xSpeed*blocksize) == 0 and v2.xSpeed > 0) then
			if v1.leftcollide then
				if v1:leftcollide(v2, v2name) == "nocollide" then
					return false, false
				end
			end
		end
		if not v1.passive and not v2.passive then
			v1.xSpeed = 0
		end
	end
	if v1.passive or v2.passive then
		hor, ver  = false, false
	end
	return hor, ver
end

function aabb(v1x, v1y, v1width, v1height, v2x, v2y, v2width, v2height)
	local v1farx, v1fary, v2farx, v2fary = v1x + v1width, v1y + v1height, v2x + v2width, v2y + v2height
	return v1farx > v2x and v1x < v2farx and v1fary > v2y and v1y < v2fary
end 
local min,max = math.min, math.max

--From love forums
function findlineIntersect(l1p1x, l1p1y, l1p2x,l1p2y, l2p1x,l2p1y, l2p2x,l2p2y, seg1, seg2)
    local a1,b1,a2,b2 = l1p2y-l1p1y, l1p1x-l1p2x, l2p2y-l2p1y, l2p1x-l2p2x
    local c1,c2 = a1*l1p1x+b1*l1p1y, a2*l2p1x+b2*l2p1y
    local det,x,y = a1*b2 - a2*b1
    if det==0 then return false, "The lines are parallel." end
    x,y = (b2*c1-b1*c2)/det, (a1*c2-a2*c1)/det
    if seg1 or seg2 then

        if seg1 and not (min(l1p1x,l1p2x) <= x and x <= max(l1p1x,l1p2x) and min(l1p1y,l1p2y) <= y and y <= max(l1p1y,l1p2y)) or
           seg2 and not (min(l2p1x,l2p2x) <= x and x <= max(l2p1x,l2p2x) and min(l2p1y,l2p2y) <= y and y <= max(l2p1y,l2p2y)) then
            return false, "The lines don't intersect."
        end
    end
    return x,y
end