local ceil = math.ceil

function resetcollisionoptions()
	collisionoptions = {}
	collisionoptions["player"] = {"all"}
end
resetcollisionoptions()

function physicsupdate(dt)
	for v1name, table in pairs(objects) do
		if v1name ~= blockname then
			for index, v1 in pairs(table) do
				local cancollide = false
				if not v1.static and v1.active then
					cancollide = true
				end
				local hor, ver = false, false
				local hitmovebelt, movebelttype = false
				if cancollide then
					if v1.shouldfall then
						
						v1.ySpeed = v1.ySpeed + (v1.gravity or gravity) * dt	
					end

					--Against all objects but blocks
					for v2name, table2 in pairs(objects) do
						--if v2name ~= blockname then
							local cancollide = false
							if collisionoptions[v1name] then
								for i, v in pairs(collisionoptions[v1name]) do
									if v == v2name or v == "all" then
										cancollide = true
									end
								end
							end
							if v2name == v1name then
								cancollide = false
								if v1name == "crate" then
									cancollide = true				
								end
							end
							if cancollide then
								local horizontal, vertical, returnedmovebelttype = checkifshouldcollide(v1, v1name, v2name, table2, index, dt)
								if horizontal then
									hor = true
								end
								if vertical then
									ver = true
								end
								if returnedmovebelttype then
									hitmovebelt = true
									movebelttype = returnedmovebelttype
								end
							end
						--end
					end

					--Against blocks in screenwidth sector

					--[[local posvsscreenwidth = ceil((v1.x-16*scale)/screenwidth)
					local widthposvsscreenwidth = ceil((v1.x+v1.width+16*scale)/screenwidth)
					if posvsscreenwidth == 0 then
						posvsscreenwidth = 1
					end
					local hitsblocks
					if collisionoptions[v1name] then
						for i, v in pairs(collisionoptions[v1name]) do
							if v == blockname or v == "all" then
								hitsblocks = true
								break
							end 
						end
					end
					if hitsblocks then
						for i = 1, #blocksections[posvsscreenwidth] do
							local v2 = objects["block"][blocksections[posvsscreenwidth][i]
							local horizontal, vertical = detectcollision(v1, v1name, v2, blockname, nil, nil, dt)
							if horizontal then
								hor = true
							end
							if vertical then
								ver = true
							end
						end

						if posvsscreenwidth ~= widthposvsscreenwidth and widthposvsscreenwidth <= #blocksections then	
			
							for i = 1, #blocksections[widthposvsscreenwidth] do
								local v2 = objects["block"][blocksections[widthposvsscreenwidth][i]
								local horizontal, vertical = detectcollision(v1, v1name, v2, blockname, nil, nil, dt)
								if horizontal then
									hor = true
								end
								if vertical then
									ver = true
								end
							end
						end
					end--]]

					if not hor then
						local speed = v1.xSpeed
						if hitmovebelt then
							if movebelttype == "left" then
								--[[local dir = "left" or v1.dir
								if v1name == "idiot" then
									if v1.holdingcrate then
										dir = "right"
									end
								end
								if dir == "left" then
									speed = speed - 49*scale
								else--]]
									speed = speed - 32*scale
								--end
							elseif movebelttype == "right" then
								--[[local dir = "right" or v1.dir
								if v1name == "idiot" then
									if v1.holdingcrate then
										dir = "left"
									end
								end
								if dir == "right" then
									speed = speed + 49*scale
								else--]]
									speed = speed + 32*scale
								--end
							end
							v1.onmovebelt = true
							v1.onmovebelttype = movebelttype
						else
							v1.onmovebelt = false
						end
						v1.x = v1.x + v1.xSpeed * dt
					end
					if not ver then
						v1.y = v1.y + v1.ySpeed * dt
					end

					if not hitmovebelt then
						v1.onmovebelt = false
					end
				end
			end
		end
	end
end

function checkifshouldcollide(v1, v1name, v2name, table2, v1index, dt)
	local hor, ver
	local movebelthit
	for v2index, v2 in pairs(table2) do
		if v2.active then
			local can = true
			if v1name == "crate" and v2name == "crate" then
				if v1 == v2 then
					can = false
				end
			end
			if v1.layer ~= v2.layer then
				can = false
			end
			--local basecollision = aabb(v1.x, v1.y, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height)
			--if basecollision then
			if can then
				local localhor, localver = detectcollision(v1, v1name, v2, v2name, v1index, v2index, dt)
				if localhor then
					hor = true
				end
				if localver then
					ver = true
				end
			end
			if v2name == "movebelt" then
				if ver then
					movebelthit = v2.type
				end
			end
		end
	end
	return hor, ver, movebelthit
end

function detectcollision(v1, v1name, v2, v2name, v1index, v2index, dt)
	local hor, ver
	local speed = v1.xSpeed
	local hitver, hithor
	local shouldcollide = true
--	if v1.xSpeed < 0 and not v1.onmovebelt then
		if not aabb(v1.x + v1.xSpeed * dt, v1.y + v1.ySpeed * dt, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
			shouldcollide = false
		end
		if v1name == "crate" and v2name == "door" then
			shouldcollide = true
		end
	--end
	if shouldcollide then

		if v1.active then
			if aabb(v1.x + v1.xSpeed * dt, v1.y, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
				hor = resolvehorcollision(v1, v1name, v2, v2name, dt)
			end
		end
		if v1.active then
			if aabb(v1.x, v1.y + v1.ySpeed * dt, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
				ver = resolvevercollision(v1, v1name, v2, v2name, v1index, v2index)
			end
		end



		--[[if not ver and not hor and aabb(v1.x + v1.xSpeed * dt, v1.y + v1.ySpeed * dt, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
			local lgravity = gravity
			if v1.gravity then
				lgravity = v1.gravity
			end
			if math.abs(v1.ySpeed-lgravity*dt) < math.abs(v1.xSpeed) then
				ver = resolvevercollision(v1, v1name, v2, v2name, v1index, v2index)
			else 
				hor = resolvehorcollision(v1, v1name, v2, v2name, dt)
			end
		end--]]
	end

	--[[if aabb(v1.x, v1.y, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
		local v1minx = v1.x --Min = top left
		local v1miny = v1.y
		local v2minx = v2.x
		local v2miny = v2.y
		local v1maxx = v1.x + v1.width -- Max = bottom right
		local v1maxy = v1.y + v1.height
		local v2maxx = v2.x + v2.width
		local v2maxy = v2.y + v2.height

		--K, we got our first set of values.		--I don't like math too much anymore

		local left = v2minx - v1maxx
		local right = v2maxx - v1minx
		local up = v2miny - v1maxy
		local down = v2maxy - v1miny
		if left > 0 or right < 0 or up > 0 or down < 0 then --Not colliding. This is the easy part lol.
			return false
		end
		local xvec, yvec = 0, 0

		if math.abs(left) < right then
			xvec = left
		else
			xvec = right
		end
		if math.abs(up) < down then
			yvec = up
		else
			yvec = down
		end

		if math.abs(xvec) < math.abs(yvec) then
			yvec = 0
		else
			xvec = 0
		end

		if xvec ~= 0 then
			hor = resolvehorcollision(v1, v1name, v2, v2name, dt, xvec)
		end
		if yvec ~= 0 then
		
			ver = resolvevercollision(v1, v1name, v2, v2name, yvec)
		end
	end--]]


	--[[if not hor and not ver and aabb(v1.x + speed*dt, v1.y + v1.ySpeed * dt, v1.width, v1.height, v2.x, v2.y, v2.width, v2.height) then
		local gravity = v1.gravity or gravity
		if math.abs(v1.ySpeed-gravity*dt) < math.abs(v1.xSpeed) then
			ver = resolvevercollision(v1, v1name, v2, v2name, v1index, v2index)
		else 
			hor = resolvehorcollision(v1, v1name, v2, v2name, dt)
		end
	end--]]


	return hor, ver

end

function resolvevercollision(v1, v1name, v2, v2name, yvec)
	local changedyspeed = false
	local finishquick = false
	local collisiontype
	if v1.ySpeed > 0 then
		if v1.downcollide then
			local collisiontype = v1:downcollide(v2, v2name)
			if collisiontype == "changed" then
				changedyspeed = true
			elseif collisiontype == "nocollide" then
				return false
			end
		end

		if v2.passive then
			return false
		end
		--v1.y = v1.y + yvec
		v1.y = v2.y - v1.height
	else

		if v1.upcollide then
			local collisiontype = v1:upcollide(v2, v2name)
			if collisiontype == "changed" then
				changedyspeed = true
			elseif collisiontype == "nocollide" then
				return false
			end
		end
		--[[local passive = false
		for i, v in pairs(v1.passiveto) do
			if i == v2name and v == true then
				passive = true
			end
		end
		if v1.passive then
			passive = true
		end--]]
		if v2.passive then
			return false
		end
		v1.y = v2.y + v2.height

	end
	if not changedyspeed and not v2.passive then
		v1.inAir = false
		v1.ySpeed = 0

	end
	return not changedyspeed, finishquick
end

function resolvehorcollision(v1, v1name, v2, v2name, dt, xvec)
	local changedxspeed = false
	local speed = v1.xSpeed

	if speed > 0 then

		if v1.rightcollide then
			local collisiontype = v1:rightcollide(v2, v2name)
			if collisiontype == "changed" then
				changedxspeed = true
			elseif collisiontype == "nocollide" then
				return false
			end
		end
		if v2.passive then
			return false
		end
		--v1.x = v1.x + xvec
		v1.x = v2.x - v1.width
		--[[if v1name == "idiot" and v2name == "door" then
			if love.keyboard.isDown("left") then
				v1.x = v2.x + v2.width - 1
			end
		end--]]
		--v1.onmovebelt = false
	elseif speed < 0 then
		if v1.leftcollide then
			local collisiontype = v1:leftcollide(v2, v2name)
			if collisiontype == "changed" then
				changedxspeed = true
			elseif collisiontype == "nocollide" then
				return false
			end
		end
		if v2.passive then
			return false
		end

		--v1.x = v1.x + xvec
		v1.x = v2.x + v2.width
		--[[if v1name == "idiot" and v2name == "door" then
			if love.keyboard.isDown("right") then
				v1.x = v2.x + v2.width + 1
			end
		end--]]
		--v1.onmovebelt = false
	end
	if not changedxspeed and not v2.passive then
		v1.xSpeed = 0
	end
	return not changedxspeed
end

function aabb(v1x, v1y, v1width, v1height, v2x, v2y, v2width, v2height)
	local v1farx, v1fary, v2farx, v2fary = v1x + v1width, v1y + v1height, v2x + v2width, v2y + v2height
	return v1farx > v2x and v1x < v2farx and v1fary > v2y and v1y < v2fary
end